// 8 May 2007
// Copyright (c) 2007, Miguel Novas
// Released under the GPL license
// http://www.gnu.org/copyleft/gpl.html
// Repartidor de escombros y recursos para compactador automatico batallas de ogame

var shareOutInfo;
var shareOutAllowed;
var shareOutAttackersCount;
var shareOutDefendersCount;

function shareout_init()
{
  shareOutInfo          = null;
  shareOutAttackersCount= count_players(atackerName);
  shareOutDefendersCount= count_players(defenderName);
  shareOutAllowed       = (shareOutAttackersCount>1 || shareOutDefendersCount>1);

  function count_players(players) {
    var count=0;
    if(players.length>1)  {
      var dummy= {};
      var count= 0;
      for(var i in players)
        if( typeof dummy[players[i]]== 'undefined' ) {
            dummy[players[i]]= 0;
            count++;
        }
    }
    return count;
  }
}

function shareout_calculate(weight, fattackers)
{
    if(!shareOutAllowed) return null;
    var shareout= shareOutInfo;
    fattackers= (fattackers || shareOutDefendersCount<2) && (shareOutAttackersCount>1);
    if(shareout==null || fattackers!=shareout.fattackers) {
     shareout= init(fattackers);
      if(shareout!=null) {
        for (var i=0; i<shareout.players.length; i++) {
          var name= shareout.players[i].split('(')[0];
          for(var j in shareout.resources) {
             resource_flotes(shareout.resources[j], name, shareout.tshipsini[i], shareout.nshipsini[i], shareout.nshipsend[i], shareout.coords[i]);
          }
        }
      }
    }
    if(shareout!=null && weight!=shareout.weight) {
      shareout.weight= weight;
      for(var i in shareout.resources) {
        resource_percents(shareout.resources[i],weight/100);
        resource_calculate(shareout.resources[i]);
      }
    }
    shareOutInfo= shareout;
    return shareout;

    function init(attackers)
    {
        var count= attackers ? shareOutAttackersCount : shareOutDefendersCount;
        if(count<=1) return null;
        return {fattackers : attackers,
                weight     : -1,
                players    : (attackers ? atackerName               : defenderName ),
                tshipsini  : (attackers ? atackerInitialShipsType   : defenderInitialShipsType ),
                nshipsini  : (attackers ? atackerInitialShipsNumber : defenderInitialShipsNumber ),
                nshipsend  : (attackers ? atackerFinalShipsNumber   : defenderFinalShipsNumber ),
                coords     : (attackers ? atackerCoords             : defenderCoords),
                resources  : {
                                metal    : { start:0, lost:0, stolen:stolenMetal+rubbleMetal,     flote:[], floteCount:0, isDeu:false, costs: shiptsMetalCost,     costsd:defensesMetalCost     },
                                crystal  : { start:0, lost:0, stolen:stolenCristal+rubbleCristal, flote:[], floteCount:0, isDeu:false, costs: shiptsCristalCost,   costsd:defensesCristalCost   },
                                deuterium: { start:0, lost:0, stolen:stolenDeuterium,             flote:[], floteCount:0, isDeu:true , costs: shiptsDeuteriumCost, costsd:defensesDeuteriumCost }
                             } };
    }

    function resource_flotes(resource, name, initialShipsType, initialShipsNumber, finalShipsNumber, coords) {

        if(typeof resource.flote[name]=='undefined') {
           resource.flote[name]= { start:0, lost:0, amount:0, profit:0, pprofit:0 };
           resource.floteCount++;
        }
        var ships   = tag('$ships');
        var defenses= tag('$defenses');
        var flote   = resource.flote[name];
        for (var i=0; i<initialShipsType.length; i++) {
          costs      = resource.costs;
          lostNumber = initialShipsNumber[i] - finalShipsNumber[i];
          iShip      = ships.indexOf(initialShipsType[i]);
          if(iShip<0) {
            iShip= defenses.indexOf(initialShipsType[i]);
            if(iShip>=0) {
              costs     = resource.costsd;
              lostNumber= parseInt( lostNumber * 0.3 );
            }
          }
          if (iShip>=0) {
            var start= costs[iShip] * initialShipsNumber[i];
            var lost = costs[iShip] * lostNumber;
            if(resource.isDeu) {
                lost+= deuteriumConsumption(initialShipsType[i], initialShipsNumber[i], coords, defenderCoords[0]);
            }
            flote.start   += start;
            flote.lost    += lost;
            resource.start+= start;
            resource.lost += lost;
          }
        }
    }

    function resource_percents(resource, weight) {
        var prest= (1-weight) / resource.floteCount;
        for(var name in resource.flote) {
          var flote= resource.flote[name];
          flote.pstart= ( flote.start / resource.start ) * weight + prest;
          flote.plost = flote.lost / resource.lost;
        }
    }

    function resource_calculate(resource) {
        var distribute= resource.stolen - resource.lost;
        for(var name in resource.flote) {
          var flote= resource.flote[name];
          if(distribute>=0) flote.amount= flote.lost + Math.round(distribute * flote.pstart);
          else              flote.amount= Math.round(resource.stolen * flote.plost);
          flote.profit = flote.amount - flote.lost;
          flote.pprofit= parseInt(flote.profit / flote.lost * 100);
        }
    }
}